//************************************************************************
// picio.h
//
// hk@holger-klabunde.de
// www.holger-klabunde.de
// 02.01.2004
// Compiler Visual C++ V5.0
//************************************************************************


#ifndef _PICIO_H
#define _PICIO_H

#include <pshpack4.h>

#define USB_BUFFSIZE	9
extern unsigned char inbuff[];   //USB input buffer. 1 byte for report, 8 bytes from the PIC
extern unsigned char outbuff[];  //USB output buffer. 1 byte for report, 8 bytes for the PIC
extern HANDLE HidHandle;

extern int WritePicPort(int port, unsigned char data);
extern unsigned char ReadPicPort(int port);
extern int WriteTris(int port, unsigned char data);
extern unsigned char ReadTris(int port);
extern unsigned char ReadADC(int adchannel);
extern int WritePWM1(unsigned int pwmvalue);
extern int WritePWM2(unsigned int pwmvalue);
extern int WritePR2(unsigned char value);

#define MY_VID	(unsigned int)0x04D8	// Microchip's Vendor ID
#define MY_PID	(unsigned int)0x1110	// Produkt ID

#define SET_PWM		0x01        // Control PWM1 or PWM2
#define GET_ADC		0x02        // Read A2D values AN0..AN4
#define IN_SER		0x03        // Get Serial Data
#define OUT_SER		0x04		// Write Data to serial port. High nibble is data count !
#define SET_PORTA	0x05        // Control PORTA or TRISA
#define SET_PORTB	0x06        // Control PORTB or TRISB
#define SET_PORTC	0x07        // Control PORTC or TRISC
#define SET_PORTD	0x08        // Control PORTD or TRISD
#define SET_PORTE	0x09        // Control PORTE or TRISE
#define GET_PORTS	0x0A        // Read PORTA to PORTE or TRISA to TRISE

#define ALL_INPUTS	0xFF		// often needed TRISx values
#define ALL_OUTPUTS 0x00

#define PORTA		0
#define PORTB		1
#define PORTC		2
#define PORTD		3
#define PORTE		4

#define TRISA		5
#define TRISB		6
#define TRISC		7
#define TRISD		8
#define TRISE		9

#define AN0			0
#define AN1			1
#define AN2			2
#define AN3			3
#define AN4			4

#define AD0			5
#define AD1			6
#define AD2			7
#define AD3			8
#define AD4			9

#define PWM1		0x01
#define PWM2		0x02
#define PR2			0x04

#include <poppack.h>

#endif //_PICIO_H
