//************************************************************************
// Setupapi.cpp
//
// Get function adress pointers from SETUPAPI.DLL by name
//
// hk@holger-klabunde.de
// www.holger-klabunde.de
// 26.12.2003
// Compiler Visual C++ V5.0
//************************************************************************
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "setupapidll.h"

DLL_SetupDiGetClassDevs SetupDiGetClassDevs;
DLL_SetupDiEnumDeviceInterfaces SetupDiEnumDeviceInterfaces;
DLL_SetupDiGetDeviceInterfaceDetail SetupDiGetDeviceInterfaceDetail;
DLL_SetupDiDestroyDeviceInfoList SetupDiDestroyDeviceInfoList;

HINSTANCE hsetupapi;


//**********************************************************************************
void UnloadSetupApiDll() 
//**********************************************************************************
{
 if(hsetupapi) { FreeLibrary(hsetupapi); hsetupapi=NULL; }
}

//**********************************************************************************
int LoadSetupApiDll()
//**********************************************************************************
{
 hsetupapi = LoadLibrary("setupapi.dll");	
 if(hsetupapi == NULL)
  {
   MessageBox(NULL,"Error: Can't Load setupapi.dll",NULL,MB_OK);
   return 0;
  }
 else
  {
   //Get dll function entrys by function name
   if(!(SetupDiGetClassDevs = (DLL_SetupDiGetClassDevs)GetProcAddress(hsetupapi,"SetupDiGetClassDevsA")))
    {
     MessageBox(NULL,"Error: Can't find SetupDiGetClassDevsA() in setupapi.dll",NULL,MB_OK);
     return 0;
    }

   if(!(SetupDiEnumDeviceInterfaces = (DLL_SetupDiEnumDeviceInterfaces)GetProcAddress(hsetupapi,"SetupDiEnumDeviceInterfaces")))
    {
     MessageBox(NULL,"Error: Can't find SetupDiEnumDeviceInterfaces() in setupapi.dll",NULL,MB_OK);
     return 0;
    }

   if(!(SetupDiGetDeviceInterfaceDetail = (DLL_SetupDiGetDeviceInterfaceDetail)GetProcAddress(hsetupapi,"SetupDiGetDeviceInterfaceDetailA")))
    {
     MessageBox(NULL,"Error: Can't find SetupDiGetDeviceInterfaceDetailA() in setupapi.dll",NULL,MB_OK);
     return 0;
    }

   if(!(SetupDiDestroyDeviceInfoList = (DLL_SetupDiDestroyDeviceInfoList)GetProcAddress(hsetupapi,"SetupDiDestroyDeviceInfoList")))
    {
     MessageBox(NULL,"Error: Can't find SetupDiDestroyDeviceInfoList() in setupapi.dll",NULL,MB_OK);
     return 0;
    }

  }

 return 1;
}

